//  File BRMCOLL.CPP  Insert broom balancing setup variables
//                    into collection.

//  This code will not compile separately!  It must be included as
//     part of xxxsetup.cpp files that use Turbo Vision.
//  Include this file after uisetup.cpp in xxxsetup.cpp files
//     that need broom balancing variables setup.

#ifndef BRMCOLL_CPP
#define BRMCOLL_CPP

extern "C" {
  #include "brm.h"
  }

tbrm_setup_rec g_brm_setup;

void brm_setup_to_collection (tbrm_setup_rec *the_brm_setup,
   TDataCollection *the_collection)
   {
      void * value_ptr = NULL;
      tdata_type the_type = REAL_DATA;
      unsigned short len = 5;
      boolean the_check = TRUE;
      unsigned short dec_places = 2;
      float the_max = MAX_FORCE;
      float the_min = 0.0;
      boolean enable = TRUE;
      int item_no = 0;

   value_ptr = &the_brm_setup->rand_force;
   item_no += 1;
   the_collection->insert (new tcolor_data_obj (
	 "Random Force",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_brm_setup->system_force_incr;
   item_no += 1;
   the_collection->insert (new tcolor_data_obj (
	 "System Force Incr",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_brm_setup->user_force_incr;
   item_no += 1;
   the_collection->insert (new tcolor_data_obj (
	 "User Force Incr",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_brm_setup->zero_theta;
   len = 7;
   dec_places = 4;
   item_no += 1;
   the_collection->insert (new tcolor_data_obj (
	 "Zero Theta Tolerance",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   return;
   }

#endif