
/* File FFIN.H  Header file for FF network financial modeling  */

#ifndef FFIN_H
#define FFIN_H

#include "uttypes.h"
#include "ff.h"

#define MAX_NO_OF_INPUT_NODES 10
#define MAX_NO_OF_OUTPUT_NODES 5

typedef struct {
     int year,qtr;
     } qtr_date;

typedef struct {
     path_str file_name;
     qtr_date start;
     } node_data;

typedef struct {
     int no_of_data_points, no_of_look_ahead_points, no_of_input_nodes,
	 no_of_output_nodes;
     node_data input_node_data[MAX_NO_OF_INPUT_NODES],
	       output_node_data[MAX_NO_OF_OUTPUT_NODES];
     } ffin_training_rec;

#define MAX_NO_OF_DATA_YEARS 30
#define MAX_NO_OF_INPUT_ITEMS 4*MAX_NO_OF_DATA_YEARS+8

typedef float tdata_arr[MAX_NO_OF_INPUT_ITEMS];

/*  FFINCTRN.C  */
void initialize_ffin_training_rec (ff_setup_rec ff_setup,
     ffin_training_rec *the_rec);
void create_training_file (ff_setup_rec setup,ffin_training_rec the_rec);

/*  FFINRUN.C  */
void run_ffin_network (ff_setup_rec setup);

#endif