// File FLGSYS.CPP Fuzzy Logic - Genetic Algorithm Modeling with
//               Turbo Vision interface

extern "C" {
   #include "trn.h"
   #include "flga.h"
   }

#include "flgsetup.cpp"

tflg_setup_rec g_flg_rec;

void handle_system (system_response *control_flag)
  {
   tflgsetapp *Setup_App = new tflgsetapp();
   quit_flag = quit;
   Setup_App->run();
   Setup_App->destroy (Setup_App);
   *control_flag = quit_flag;
   }

int main()
   {
   const int pop_size = 50,bit_len = 3;
   int j,no_of_rules = 1;
   system_response prog_control = startup;
   init_flga_setup (&g_flg_rec);
   for (j = 1;j<=g_flg_rec.no_of_fl_inputs;j++)
       no_of_rules *= g_flg_rec.no_of_fl_inp_regions;
   initialize_ga_setup (pop_size,bit_len,no_of_rules,
	&ga_setup_rec);
   strcpy (system_name,"Fuzzy - Genetic Modeling");
   display_startup_message();
   do
   {
   handle_system(&prog_control);
   switch (prog_control) {
   case run_net:
      run_fuzzy_model(g_flg_rec);
      break;
   case train_net:
      fl_genetic_training (&g_flg_rec,&ga_setup_rec,&ga_rec);
      break;
   }
   } while (prog_control != quit);
   return 0;
   } // end main