//  File GACOLL.CPP  Genetic algorithm setup collection procedures.

//  This code will not compile separately!  It must be included as
//     part of xxxsetup.cpp files that use Turbo Vision.
//  Include this file after uisetup.cpp in xxxsetup.cpp files
//     that need ga setup.

#ifndef GACOLL_CPP
#define GACOLL_CPP

extern "C" {
  #include "ga.h"
  }

int bit_len_item_no;

void ga_setup_to_collection (tga_setup_rec *the_ga_setup,
   TDataCollection *the_collection)
   {
      void * value_ptr = NULL;
      tdata_type the_type;
      unsigned short len;
      boolean the_check = TRUE;
      unsigned short dec_places = 0;
      float the_max = 0.0;
      float the_min = 0.0;
      boolean enable = TRUE;
      int item_no = 0;

   value_ptr = &the_ga_setup->population_size;
   the_type = INT_DATA;
   len = 4;
   dec_places = 0;
   the_max = 9999;
   the_min = 2;
   item_no += 1;
   the_collection->insert (new tcolor_data_obj (
	 "Population Size",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_ga_setup->bit_len;
   the_type = INT_DATA;
   len = 2;
   dec_places = 0;
   the_max = 8 * sizeof(unsigned int); // Type is *vector.vect
   the_min = 1;
   item_no += 1;
   bit_len_item_no = item_no;
   the_collection->insert (new tcolor_data_obj (
	 "Bit Length",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_ga_setup->pick_fittest;
   the_type = BOOLEAN_DATA;
   len = 3;
   dec_places = 0;
   item_no += 1;
   the_collection->insert (new tcolor_data_obj (
	 "Pick Fittest?",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_ga_setup->max_gens;
   the_type = INT_DATA;
   len = 5;
   dec_places = 0;
   the_max = 99999;
   the_min = 1;
   item_no += 1;
   the_collection->insert (new tcolor_data_obj (
	 "Max Iterations",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_ga_setup->crossover_prob;
   the_type = REAL_DATA;
   len = 6;
   dec_places = 4;
   the_max = 1.0;
   the_min = 0.0;
   item_no += 1;
   the_collection->insert (new tcolor_data_obj (
	 "Crossover Probability",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_ga_setup->mutation_prob;
   the_type = REAL_DATA;
   item_no += 1;
   the_collection->insert (new tcolor_data_obj (
	 "Mutation Probability",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_ga_setup->tolerance;
   the_type = REAL_DATA;
   the_max = 1.0;
   the_min = 0.0;
   len = 8;
   dec_places = 6;
   item_no += 1;
   the_collection->insert (new tcolor_data_obj (
	 "Tolerance",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));
   return;
   }

#endif